import trees.bintree.*;

import java.io.*;

class MyTreeData implements  TreeData<String> {

    String data;

    public MyTreeData(String x) {
	data = x;
    }

    public String getData() {
	return data;
    }

    public int compareTo(TreeData<String> x) {
	return data.compareTo(x.getData());
    }

    public String toString() {
	return data;
    }

}


class MyTree {

	public static void main(String[] args) {

		Bintree n0 = new Bintree();

		try {

			BufferedReader f
			= new BufferedReader(new FileReader(args[0]));
			String s = f.readLine();
			while ( s != null ) {
				n0.insert(new MyTreeData(s));
				s = f.readLine();
			}
			f.close();

		}
		catch (FileNotFoundException e) {
			System.out.println(e);
			return;
		}
		catch (IOException e) {
			System.out.println(e);
			return;
		}
		catch (ArrayIndexOutOfBoundsException e) {
			System.out.println("Kein Argument angegeben:\n" + e);
			return;
		}

		System.out.println("EINGELESENER BAUM:\n" + n0.toString());

                MyTreeData x = new MyTreeData("3");
                assert n0.find(x)
		    : "String 3 nicht gefunden";

                assert n0.delete(x)
		    : "String 3 nicht gelöscht";

                System.out.println("NACH DEM LOESCHEN von 3:\n" 
                                    + n0.toString());

		x = new MyTreeData("6");
                assert n0.find(x)
		    : "String 6 nicht gefunden";

                assert n0.delete(x)
		    : "String 6 nicht gelöscht";

                System.out.println("NACH DEM LOESCHEN von 6:\n" 
                                    + n0.toString());


	}

}
